import 'package:dartz/dartz.dart';
import 'package:food_delivery_client/core/services/request_handler_service.dart';
import 'package:food_delivery_client/feature/auth/data/datasource/auth_datasource.dart';
import 'package:food_delivery_client/feature/auth/data/models/response/login_response.dart';
import 'package:food_delivery_client/food_delivery_client.dart';

import '../usecases/register_usecase.dart';
import '../usecases/reset_password_usecase.dart';
import '../usecases/verify_otp_code_login_usecase.dart';
import '../usecases/verify_phone_login_usecase.dart';

abstract class AuthRepository {
  Future<Either<Failure, LoginResponseModel>> login({
    required String phoneNumber,
    required String password,
  });

  Future<Either<Failure, SuccessModel>> verifyPhoneResetPassword({
    required VerifyPhoneNumberParams params,
  });

  Future<Either<Failure, SuccessModel>> verifyOtpCodeResetPassword({
    required VerifyOtpCodeParams params,
  });

  Future<Either<Failure, SuccessModel>> resetPassword({
    required ResetPasswordParams params,
  });

  Future<Either<Failure, SuccessModel>> verifyPhoneRegister({
    required VerifyPhoneNumberParams params,
  });

  Future<Either<Failure, SuccessModel>> verifyOtpCodeRegister({
    required VerifyOtpCodeParams params,
  });

  Future<Either<Failure, SuccessModel>> register({
    required RegisterParams params,
  });
}


